<template>
  <div class="mb-8 flex flex-wrap gap-4">
    <ui-button @click="$loading.show">Show loading</ui-button>
    <ui-button :disabled="!isActive" @click="$loading.hide"
      >Hide loading</ui-button
    >
    <ui-button
      :disabled="!isActive || steps.length === exampleSteps.length"
      @click="$loading.addStep(exampleSteps[steps.length])"
    >
      Add step
    </ui-button>
    <ui-button
      :disabled="!isActive || !steps.length"
      @click="
        $loading.updateStep(lastStepId, {
          status: LoadingStepStatus.Skipped,
        })
      "
    >
      Update last step
    </ui-button>
    <ui-button
      :disabled="!isActive || !steps.length"
      @click="$loading.removeStep(lastStepId)"
    >
      Remove last step
    </ui-button>
    <ui-button
      :disabled="!isActive || !steps.length"
      @click="$loading.clearSteps()"
    >
      Clear steps
    </ui-button>
  </div>
  <ui-loading
    :is-active="isActive"
    label="Loading, please wait!"
    :steps="steps"
  />
</template>

<script lang="ts" setup>
import { computed } from 'vue'
import { useLoading } from '@/composables'
import { LoadingStepStatus } from '@/enums'

const { isActive, steps, $loading } = useLoading()

const lastStepId = computed(() => steps.value[steps.value.length - 1].id)

const exampleSteps = [
  { id: 0, label: 'Fetching episodes', status: LoadingStepStatus.Done },
  {
    id: 1,
    label: 'Determining latest valid episode',
    status: LoadingStepStatus.Done,
  },
  { id: 2, label: 'Fetching form states', status: LoadingStepStatus.Running },
  {
    id: 3,
    label: 'Merging with Journey forms',
    status: LoadingStepStatus.Pending,
  },
  {
    id: 4,
    label: 'Removing completed forms',
    status: LoadingStepStatus.Pending,
  },
]
</script>
